#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct il { struct il *nxt; char *name; } ilist_t;
typedef struct ll { struct ll *nxt; ilist_t *il; } level_t;

#define IS_I(s)		(*(uint16_t *)s == 'i')

char *mkname(char *s, int c) {		// if [ keep room for ]
  unsigned l = strlen(s);
  char *p = malloc(l + 2*(c == '[') + 1);
  strcpy(p, s);
  if (c == '[') { p[l] = '['; p[l+1] = '\0'; }
  return p;
}

void printfree(ilist_t *il, int print) {
  for (ilist_t *n; il; il = n) {
    if (print) { fputs(il->name, stdout); putchar(' '); }
    free(il->name);
    n = il->nxt;
    free(il);
  }
}

void printlevels(level_t *lvl) {
  do printfree(lvl->il, 1); while ((lvl = lvl->nxt));
}

int do_prog(level_t *top, level_t **nxt) {	// if !top print 
  ilist_t *fst = NULL, **pi = &fst;
  char s[32];
  while (scanf(" %30[a-z] ", s) == 1) {
    int c = getchar();
    if (top)				// save
      if (IS_I(s) && c != '[') {	// interesting: print outstanding
	printlevels(top); top = NULL;	// previous levels
	printfree(fst, 1); fst = NULL;  // current level
	fputs("i ", stdout);		// current statement
      } else {				// save in list
	*pi = malloc(sizeof(ilist_t));
	(*pi)->name = mkname(s, c);
	*(pi = &(*pi)->nxt) = NULL;
      }
    else { fputs(s, stdout); putchar(' '); }	// print name
    if (c == '[') {				// compound statement
      if (!top) fputs("[ ", stdout);
      level_t lvl = (level_t){ NULL, fst };
      if (top) *nxt = &lvl;
      if (do_prog(top ? top : &lvl, &lvl.nxt)) { top = NULL; fst = NULL; }
      if (top) { *nxt = NULL; strcat(((ilist_t*)pi)->name, "]"); }
      else fputs("] ", stdout);
      if (getchar() != ']') exit(1);		// matching ]
    } else if (c != EOF) ungetc(c, stdin);	// not [, put back
  }
  if (top) printfree(fst, 0);
  return top == NULL;
}

int main(void) {
  freopen("program.in", "r", stdin);
  freopen("program.out", "w", stdout);
  do_prog(NULL, NULL);
  return 0;
}
